#! /usr/bin/python3 -B

import sys
import os
import subprocess
import regex as re

cwd = os.path.realpath(os.getcwd())

script = os.path.realpath(sys.argv[0])

testdir = os.path.dirname(script)

if len(sys.argv) < 2:
	print("usage: {} toybox_dir".format(script))
	sys.exit(1)

toybox = sys.argv[1].rstrip(os.sep)

toybox_bc = toybox + "/toys/pending/bc.c"

os.chdir(testdir)
os.chdir("..")

res = subprocess.run(["make", "bc_mathlib"])

if res.returncode != 0:
	sys.exit(res.returncode)

content = ""

with open(testdir + "/files.txt") as f:
	files = f.read().splitlines()

for name in files:

	with open(name) as f:
		lines = f.readlines()

	# Skip the header lines.
	for i in range(22, len(lines)):
		content += lines[i]

regexes = [ '^#include .*$', '^#ifndef BC.*_H$', '^#define BC.*_H$', '^#endif \/\/ BC.*_H$', '^extern.*$' ]

for reg in regexes:
	r = re.compile(reg, re.M)
	content = r.sub('', content)

with open(testdir + "/header.c") as f:
	content = f.read() + content

with open(testdir + "/footer.c") as f:
	content += f.read()

content = re.sub('\n\n\n+', '\n\n', content)

os.chdir(cwd)

with open(toybox_bc, 'w') as f:
	f.write(content)
